## hvcc 0.14.0

=== hvcc/generators/c2daisy/templates/Makefile ===
# Project Name
TARGET = HeavyDaisy_{{name}}

# Library Locations
LIBDAISY_DIR = {{libdaisy_path}}

{% if linker_script != '' %}
LDSCRIPT = {{linker_script}}
{% endif %}

{% if bootloader != None %}
APP_TYPE = {{bootloader}}
{% endif %}

{% if debug_printing is sameas true %}
LDFLAGS += -u _printf_float
{% endif %}

# Project Source
C_SOURCES = $(wildcard *.c)
CPP_SOURCES = $(wildcard *.cpp)

# Core location, and generic makefile.
SYSTEM_FILES_DIR = $(LIBDAISY_DIR)/core
include $(SYSTEM_FILES_DIR)/Makefile

=== hvcc/generators/c2fmod/templates/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.29.0)

project({{name}})

if(NOT IS_DIRECTORY ${CMAKE_SOURCE_DIR}/include/fmod)
  message(FATAL_ERROR "FMOD SDK MISSING: ${CMAKE_SOURCE_DIR}/include/fmod")
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED 17)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(CMAKE_STATIC_LIBRARY_PREFIX "")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/$<CONFIG>)

set(CMAKE_SHARED_LIBRARY_PREFIX "")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/$<CONFIG>)

add_library(
  objlib OBJECT
  ${CMAKE_SOURCE_DIR}/src/{{name}}.cpp
)

set_target_properties(
  objlib PROPERTIES
  POSITION_INDEPENDENT_CODE True
)

target_sources(
  objlib PRIVATE
  {%- for file in heavy_src_files %}
  ${CMAKE_SOURCE_DIR}/include/Heavy/{{file}}
  {%- endfor %}
)

target_include_directories(
  objlib PRIVATE
  ${CMAKE_SOURCE_DIR}/include/Heavy
  ${CMAKE_SOURCE_DIR}/include/fmod/core/inc
  ${CMAKE_SOURCE_DIR}/include/fmod/studio/inc
)

add_library(${PROJECT_NAME} SHARED $<TARGET_OBJECTS:objlib>)
add_library(lib${PROJECT_NAME} STATIC $<TARGET_OBJECTS:objlib>)

add_custom_command(
  TARGET ${PROJECT_NAME}
  POST_BUILD
  COMMAND ${CMAKE_COMMAND}
  ARGS -E copy ${CMAKE_SOURCE_DIR}/src/{{name}}.plugin.js
  ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/{{name}}.plugin.js
)

=== hvcc/generators/c2pdext/templates/Makefile ===
# Makefile to build class '{name}' for Pure Data.
# Needs Makefile.pdlibbuilder as helper makefile for platform-dependent build
# settings and rules.

# library name
lib.name = {{name}}

ldlibs += -lstdc++

# input source file (class name == source file basename)
class.sources = pdext/{{name}}~.c
common.sources = $(filter-out pdext/{{name}}~.c, $(wildcard pdext/*.c))
common.sources += $(wildcard pdext/*.cpp)

# all extra files to be included in binary distribution of the library
#datafiles = helloworld-help.pd helloworld-meta.pd README.md

PDLIBBUILDER_DIR=.
include $(PDLIBBUILDER_DIR)/Makefile.pdlibbuilder

=== hvcc/generators/c2unity/templates/linux/Makefile ===
CC=clang
CXX=clang++
MKDIR=mkdir -p
SRCDIR=../source
OUTDIR=../build/linux/x64/release
BASEFLAGS=-I$(SRCDIR) -DNDEBUG -msse4.1 -O3 -ffast-math -fPIC -Werror -Wno-unused-function -Wno-\#warnings
CFLAGS=$(BASEFLAGS) -std=c11
CXXFLAGS=$(BASEFLAGS) -std=c++11 -Wno-writable-strings -fno-exceptions -fno-rtti

# AudioLib
HEADERS_LIB=$(wildcard $(SRCDIR)/heavy/*.h)
HEADERS_LIB+=$(wildcard $(SRCDIR)/heavy/*.hpp)

CFILES_LIB=$(wildcard $(SRCDIR)/heavy/*.c)
OBJC_LIB=$(CFILES_LIB:%.c=%.o)

CXXFILES_LIB=$(wildcard $(SRCDIR)/heavy/*.cpp)
OBJCXX_LIB=$(CXXFILES_LIB:%.cpp=%.o)

# AudioPlugin
HEADERS_PLUG=$(HEADERS_LIB)
HEADERS_PLUG+=$(wildcard $(SRCDIR)/unity/*.hpp)

CFILES_PLUG=$(CFILES_LIB)
CFILES_PLUG+=$(wildcard $(SRCDIR)/unity/*.c)
OBJC_PLUG=$(CFILES_PLUG:%.c=%.o)

CXXFILES_PLUG=$(CXXFILES_LIB)
CXXFILES_PLUG+=$(wildcard $(SRCDIR)/unity/*.cpp)
OBJCXX_PLUG=$(CXXFILES_PLUG:%.cpp=%.o)

%.o: %.c $(HEADERS)
	$(CC) -c -o $@ $< $(CFLAGS)

%.o: %.cpp $(HEADERS)
	$(CXX) -c -o $@ $< $(CXXFLAGS)

all: directories audiolib audioplugin

directories: $(OUTDIR)

$(OUTDIR):
	$(MKDIR) $(OUTDIR)

audiolib: $(OBJC_LIB) $(OBJCXX_LIB)
	$(CXX) -o $(OUTDIR)/Hv_{{patch_name}}_AudioLib.so $^ -shared
	cp $(SRCDIR)/unity/Hv_{{patch_name}}_AudioLib.cs $(OUTDIR)

audioplugin: $(OBJC_PLUG) $(OBJCXX_PLUG)
	$(CXX) -o $(OUTDIR)/AudioPlugin_Hv_{{patch_name}}.so $^ -shared

.PHONY: clean

clean:
	rm -f $(SRCDIR)/**/*.o $(OUTDIR)/*.so $(OUTDIR)/Hv_{{patch_name}}_AudioLib.cs

## hvcc 0.13.3

=== debian/changelog ===
hvcc (0.13.3-2) unstable; urgency=medium

  * Fix Vcs-* stanzas
  * Patch to fix autopkgtest on armv6.
    Thanks to Adrian Bunk <bunk@debian.org> (Closes: #1102523)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 11 Apr 2025 10:22:51 +0200

hvcc (0.13.3-1) unstable; urgency=medium

  * New upstream version 0.13.3
    + Drop patch applied upstream
  * Fix copyright date.
  * Bump standards version to 4.7.2
  * Upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 16 Mar 2025 23:12:23 +0100

hvcc (0.13.2-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #1095553)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 09 Feb 2025 11:05:21 +0100

=== debian/control ===
Source: hvcc
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-all,
 python3-importlib-resources,
 python3-jinja2,
 python3-poetry-core,
 python3-pydantic,
 python3-setuptools,
#Testsuite: autopkgtest-pkg-python
Standards-Version: 4.7.2
Homepage: https://wasted-audio.github.io/hvcc/
Vcs-Browser: https://salsa.debian.org/multimedia-team/hvcc
Vcs-Git: https://salsa.debian.org/multimedia-team/hvcc.git

Package: python3-hvcc
Architecture: all
Depends:
 pd-lib-builder,
 ${misc:Depends},
 ${python3:Depends},
Description: heavy dataflow audio programming language transpiler (Python 3 interface)
 Heavy is a framework for easily generating audio plugins for use in interactive
 sound and music applications such games, instruments or installations.
 .
 It aims to reduce the dependency on low-level programming from a creative
 standpoint and bridge the gap from idea to production-ready implementation.
 .
 Heavy makes use of modern software principles to generate highly optimised
 C/C++ code specifically targeting a wide variety of popular hardware
 architectures and software frameworks. It can also automatically build plugin
 binaries for these platforms.
 .
 Currently Heavy supports compiling Pure Data (.pd) patch files.
 .
 This package installs the library for Python 3.

Package: hvcc
Architecture: all
Depends:
 python3-hvcc,
 ${misc:Depends},
 ${python3:Depends},
Description: heavy dataflow audio programming language transpiler
 Heavy is a framework for easily generating audio plugins for use in interactive
 sound and music applications such games, instruments or installations.
 .
 It aims to reduce the dependency on low-level programming from a creative
 standpoint and bridge the gap from idea to production-ready implementation.
 .
 Heavy makes use of modern software principles to generate highly optimised
 C/C++ code specifically targeting a wide variety of popular hardware
 architectures and software frameworks. It can also automatically build plugin
 binaries for these platforms.
 .
 Currently Heavy supports compiling Pure Data (.pd) patch files.
 .
 This package installs the 'hvcc' binary and executables

=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4
opts=dversionmangle=auto,\
     repacksuffix=+ds \
https://pypi.debian.net/hvcc/hvcc-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## hvcc 0.13.4

=== debian/changelog ===
hvcc (0.13.4-1) unstable; urgency=medium

  * Team Upload
  * Patch-out usage of python3-importlib-resources backport

  [ IOhannes m zmölnig (Debian/GNU) ]
  * New upstream version 0.13.4
    + Drop patches applied upstream

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Aug 2025 23:02:32 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
  dh-sequence-python3,
  pybuild-plugin-pyproject,
  python3-all,
- python3-importlib-resources,
  python3-jinja2,
  python3-poetry-core,
  python3-pydantic,

## hvcc 0.14.0

=== debian/changelog ===
hvcc (0.14.0-1) unstable; urgency=medium

  [ IOhannes m zmölnig ]
  * New upstream version 0.14.0
    + Drop obsolete patches
  * Put python3-hvcc into section 'python'
  * Update copyright information
    + Add new licenses
    + Re-generate d/copyright_hints
    + Add licenserecon override
  * Modernize d/watch to version 5

  [ Alexandre Detiste ]
  * Sent patch upstream

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 30 Sep 2025 08:19:07 +0200

=== debian/control ===
--- 
+++ 
@@ -22,6 +22,7 @@
 
 Package: python3-hvcc
 Architecture: all
+Section: python
 Depends:
  pd-lib-builder,
  ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export PYBUILD_NAME=hvcc
export PYBUILD_AFTER_INSTALL_python3=mv '{destdir}/usr/bin/'* '{dir}/debian/tmp/usr/bin'

%:
	dh $@ --buildsystem=pybuild

execute_before_dh_auto_install:
	mkdir -p debian/tmp/usr/bin

################ d/copyright helper ##############
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/tests/control ===
Tests:
 clap-test,
Restrictions:
 allow-stderr,
Depends:
 build-essential,
 hvcc,
 pd-lib-builder,
 puredata-core,

=== debian/watch ===
Version: 5

Source: https://pypi.debian.net/hvcc/
Matching-Pattern: hvcc-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
Dversionmangle: auto
Repacksuffix: +ds

## hvcc 0.15.0

=== hvcc/generators/c2daisy/templates/Makefile ===
--- 
+++ 
@@ -23,3 +23,5 @@
 # Core location, and generic makefile.
 SYSTEM_FILES_DIR = $(LIBDAISY_DIR)/core
 include $(SYSTEM_FILES_DIR)/Makefile
+
+CFLAGS += -DHV_BARE_METAL

=== hvcc/generators/c2unity/templates/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.29.0)

project(Hv_{{name}})
set(TARGET_NAME_LIB ${PROJECT_NAME}_AudioLib)
set(TARGET_NAME_PLUGIN ${PROJECT_NAME}_AudioPlugin)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED 17)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(CMAKE_STATIC_LIBRARY_PREFIX "")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/$<CONFIG>)

set(CMAKE_SHARED_LIBRARY_PREFIX "")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/$<CONFIG>)

include(FetchContent)

FetchContent_Declare(
    unitysdk
    DOWNLOAD_EXTRACT_TIMESTAMP OFF
    URL https://github.com/Unity-Technologies/NativeAudioPlugins/archive/refs/heads/master.zip
    SOURCE_DIR "${CMAKE_SOURCE_DIR}/vendor/UnityAudioSDK"
    PATCH_COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/src/PluginList.h ${CMAKE_SOURCE_DIR}/vendor/UnityAudioSDK/NativeCode
)

FetchContent_GetProperties(unitysdk)
if (NOT unitysdk_POPULATED)
    FetchContent_MakeAvailable(unitysdk)
endif()

add_library(
  objlib OBJECT
)

set_target_properties(
  objlib PROPERTIES
  POSITION_INDEPENDENT_CODE True
)

target_sources(
  objlib PRIVATE
  {%- for file in heavy_src_files %}
  ${CMAKE_SOURCE_DIR}/include/Heavy/{{file}}
  {%- endfor %}
)

target_include_directories(
  objlib PRIVATE
  ${CMAKE_SOURCE_DIR}/include/Heavy
)

add_library(${TARGET_NAME_LIB} SHARED $<TARGET_OBJECTS:objlib>)

add_custom_command(
  TARGET ${TARGET_NAME_LIB}
  POST_BUILD
  COMMAND ${CMAKE_COMMAND}
  ARGS -E copy ${CMAKE_SOURCE_DIR}/src/Hv_{{name}}_AudioLib.cs
  ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/Hv_{{name}}_AudioLib.cs
)

add_library(${TARGET_NAME_PLUGIN} SHARED $<TARGET_OBJECTS:objlib>)

target_sources(
  ${TARGET_NAME_PLUGIN} PRIVATE
  ${CMAKE_SOURCE_DIR}/src/{{name}}.cpp
  ${CMAKE_SOURCE_DIR}/vendor/UnityAudioSDK/NativeCode/AudioPluginUtil.cpp
)

target_include_directories(
  ${TARGET_NAME_PLUGIN} PRIVATE
  ${CMAKE_SOURCE_DIR}/include/Heavy
  ${CMAKE_SOURCE_DIR}/vendor/UnityAudioSDK/NativeCode
)

=== debian/changelog ===
hvcc (0.15.0-1) unstable; urgency=medium

  * New upstream version 0.15.0
  + Add missing new B-Ds
  * Drop obsolete 'Priority: optional' stanza.
  * Drop obsolete Rules-Requires-Root stanza.
  * Update copyright information
    + Update d/copyright
    + List some GPL-3-only files
    + Re-generate d/copyright_hints
  * Bump standards version to 4.7.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 25 Dec 2025 22:10:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,21 @@
 Source: hvcc
 Section: sound
-Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,
  pybuild-plugin-pyproject,
  python3-all,
+ python3-arpeggio,
  python3-jinja2,
  python3-poetry-core,
  python3-pydantic,
+ python3-pydantic-extra-types,
  python3-setuptools,
 #Testsuite: autopkgtest-pkg-python
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://wasted-audio.github.io/hvcc/
 Vcs-Browser: https://salsa.debian.org/multimedia-team/hvcc
 Vcs-Git: https://salsa.debian.org/multimedia-team/hvcc.git
